#!/usr/bin/perl

# Version/Other: 3.26
# Licensed to: Robert R FLower
# Downloaded on: 8/21/00, 9:11 p.m.
# IP Address: 24.64.143.114
# Session: JvNsWNqK


#############################################
#                                           #
#                                           #
#        Home Free 3.26             #
#        Solution Scripts                   #
#        Copyright 1997-2000                #
#        http://solutionscripts.com         #
#                                           #
#                                           #
# Using, selling, distrubiting the code for #
# this program without prior written        #
# consent is expressly forbidden. In all    #
# cases all copyrights and downoad stamps   #
# MUST remain intact. Lots of time and      #
# energy has go into the creation of this   #
# program, please respect our work. Thanks  #
#                                           #
#                                           #
#############################################


$|=1;

BEGIN {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");
}

require "variables.pl";
require "acc_auth.pl";
require "dblib.pl";
require "header_footer.pl";

print "Content-type: text/html\n\n ";

&Account::initialize;

&Account::verify_user;

if ($INPUT{'log'}) { &log; }
elsif ($INPUT{'action'} eq "delete file") { &delete; }
elsif ($INPUT{'action'} eq "new") { &new; }
elsif ($INPUT{'delete'}) { &delete; }
elsif ($INPUT{'edit'}) { &edit; }
elsif ($INPUT{'edit_adv'}) { &edit_adv; }
elsif ($INPUT{'edit_final'}) { &edit_final; }
elsif ($INPUT{'renamer'}) { &rename; }
elsif ($INPUT{'rename'}) { &rename; }
elsif ($INPUT{'rename_final'}) { &rename_final; }

elsif ($INPUT{'new'}) { &new; }

else { print "sorry...$INPUT{'action'}"; }


########## RENAME FILES ##########
sub rename {

if ($INPUT{'sfile'}) {
	@del_files = split(/\,/,$INPUT{'sfile'});
}
else {
	$del_files[0] = $INPUT{'rename'};
	$INPUT{'sfile'} = $INPUT{'rename'};
}

unless ($INPUT{'sfile'}) {
	&Account::header($lang::a13);
	print "$lang::uf1<BR>";
	&Account::footer;
	exit;
}	

&Account::header($lang::uf2);

print <<EOF;
<FORM METHOD=POST ACTION="$cgiurl">
$Account::hidden_variables
<input type="Hidden" name="dir" value="$INPUT{'dir'}">
<input type="Hidden" name="sfile" value="$INPUT{'sfile'}">
<font face=$font_face>$lang::uf3<BR>
<TABLE cellpadding=8 border=0>
EOF

foreach $file(@del_files) {
print <<EOF;
<TR><TD align=left><font face=$font_face><B>$file</B> -&gt;</font></TD>
<TD><INPUT TYPE="TEXT" NAME="$file"></TD></TR>
EOF
}
print <<EOF;
<TR><TD align=center colspan=2>
<BR><INPUT TYPE="SUBMIT" NAME="rename_final" VALUE="$lang::uf4">
</TD></TR></TABLE>
</form>
EOF
&Account::footer;
exit;

}

########## RENAME FILENAMES FINAL ##########
sub rename_final {

@del_files = split(/\,/,$INPUT{'sfile'});

$t_errors = 0;
$message = "<font face=$font_face>$lang::uf5<BR><TABLE cellpadding=8 border=0>";
$error = "<font face=$font_face>$lang::uf6<BR><TABLE cellpadding=8 border=0>";

foreach $file(@del_files) {
	$errors = 0;
	$found = 0;
	if ($INPUT{$file}) {
		@filename=split(/\./,$INPUT{$file});
		$ext = "." . $filename[1];
		$base_name = $filename[0];
		@out = split(//,$base_name);
		$a=0;
		foreach $char (@out) {
			$a++;	
			unless (($char =~ /[a-z]/) || ($char =~ /[A-Z]/) || ($char =~ /[0-9]/) || ($char =~ /_/)){
				$error .= "<TR><TD align=center><font face=$font_face><B>$file -- $lang::uf7</B></font></TD></TR>";
				$errors = 1;
				last;
			}
		}
		unless ($a) {
			# You must enter a file name
			$error .= "<font face=$font_face><B>$lang::uf8</B></font><BR></b>";
			$errors = 1;
		}
		unless ($ext && ($good_types{$ext})) {
			# Invalid file type
			$error .= "<font face=$font_face><B>$ext -- $lang::uf9</B></font><BR>";
			$errors = 1;
		}

		unless ($errors) {
			$re_message=1;
			rename  ("$dir_plus/$file" , "$dir_plus/$INPUT{$file}") || &error("no rename $dir_plus/$file -$dir_plus/$INPUT{$file}");
			$message .= "<TR><TD align=center><font face=$font_face><B>$file --\&gt; $INPUT{$file}</B></font></TD></TR>";
		}
	}

}

$message .= "</TABLE><BR>";

if ($errors) {
	$error .= "</TABLE>";
	if ($re_message) {
		$message .= $error;
	}
	else {
		$message = $error;
	}
}

&Account::header($lang::uf2);
print <<EOF;
$message
<BR><BR>
$lang::um57<B>
<A HREF="$files::manage?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}">$lang::um1</A>
</B>
<BR><BR>
EOF
&Account::footer;
exit;
}


########## EDIT A FILE ##########
sub edit {

if ($INPUT{'sfile'}) {
	if ($INPUT{'sfile'} =~ /,/) {

		print "$lang::uf16<BR>";	# Please select only one file to edit
		&Footer;
		exit;
	}
}
else {
	$INPUT{'sfile'} = $INPUT{'edit'};
}

unless ($INPUT{'sfile'}) {
	print "$lang::uf17<BR>"; # You must select a file to edit
	&Footer;
	exit;
}	

$file = $INPUT{'sfile'};

if ($file =~ /\.\./) {
	&error("hacking attempt");
}

undef $/;
open (DAT,"<$dir_plus/$file") || &error("nope $dir_plus/$file");
$content = <DAT>;
close (DAT);
$/ ="\n";
$"='';

&Account::header($lang::um1,"$files::manage?account=$Account::account\&session=$Account::session\&dir=$INPUT{'dir'}",$lang::uf18);


if ($content =~ /<!--START EZ_WEB TEMP-->/) {

@gettemp = split(/\%\%/,$content);

print <<EOF; 
<TABLE border=0 width=450><TR><TD>
<font face=$font_face size=$font_size><B>$file</B> $lang::uf9
<BR><BR><B>
<A HREF="$files::templates?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}&file=$file&template=$gettemp[2]">$lang::uf10</A>
</B><BR><BR>
</TD></TR></TABLE>
EOF

$content =~ s/<!--START EZ_WEB TEMP-->(.|\n)*?<!--END EZ_WEB TEMP-->\n//gm;
}
elsif ($content =~ /<!--START EZ_WEB HTML-->/) {

@gettemp = split(/\%\%/,$content);

print <<EOF; 

<TABLE border=0 width=400><TR><TD>
<font face=$font_face size=$font_size><B>$file</B> 
$lang::uf11
<BR><BR><B>
<A HREF="$files::ez_web?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}&file=$file">$lang::uf12</A>
</B><BR><BR>
</TD></TR></TABLE>
EOF

$content =~ s/<!--START EZ_WEB HTML-->(.|\n)*?<!--END EZ_WEB HTML-->\n//gm;
}

$content = &headers::remove($content);
$content =~ s/<\/TEXTAREA>/<\%\%TEXTAREA>/ig;

$textarea = "ROWS=20 COLS=45";

print qq~
<script language="JavaScript">
<!--
function Preview() {
    var htmlWnd=window.open("","html","width=600,height=480,scrollbars=yes,resizable=yes,status=0");
    htmlWnd.document.open();
    htmlWnd.document.writeln(document.html.filecontents.value);
    htmlWnd.document.writeln('<BR><p><hr noshade width="100%"><a href="javascript:window.close()">Done - Close Window</a><BR><BR>');
    htmlWnd.document.close();
}
//-->
</SCRIPT>
<FORM METHOD=POST ACTION="$cgiurl" name="html">
$Account::hidden_variables
<input type="Hidden" name="dir" value="$INPUT{'dir'}">
<input type="Hidden" name="sfile" value="$INPUT{'sfile'}">
<font face=$font_face><B>Edit the file: <font color=$text_highlight>$file</FONT></B>
<BR><BR><font size=$font_size>$lang::uf13 
~;

if ($Account::browser eq "IE") {
print <<EOF;
<SMALL>- <A HREF="$files::files?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}&edit_adv=$INPUT{'sfile'}"><SMALL>$lang::uf14</SMALL></A>
</SMALL>
EOF
$textarea = "ROWS=25 COLS=65";
}
print <<EOF;
<BR></FONT>
<TEXTAREA NAME="filecontents" $textarea wrap="OFF">$content</TEXTAREA>
<BR><BR>
<INPUT TYPE="SUBMIT" NAME="edit_final" VALUE="$lang::uf15">
<font face=$font_face><SMALL>[<a href="javascript:void(0);" onClick="Preview()">preview file</a>]</SMALL>

</form>

EOF
$" =' ';
&Account::footer;
exit;
}

sub edit_adv {
########## EDIT A FILE ##########

if ($INPUT{'sfile'}) {
	if ($INPUT{'sfile'} =~ /,/) {
		print "Please select only one file to edit<BR>";
		&Footer;
		exit;
	}
}
else {
	$INPUT{'sfile'} = $INPUT{'edit_adv'};
}

unless ($INPUT{'sfile'}) {
	print "$lang::uf17<BR>";
	&Footer;
	exit;
}	

$file = $INPUT{'sfile'};

if ($file =~ /\.\./) {
	&error("hacking attempt");
}

undef $/;
open (DAT,"<$dir_plus/$file") || &error("nope $dir_plus/$file");
$content = <DAT>;
close (DAT);
$/ =1;
$"='';

$content =~ s/<!--START EZ_WEB TEMP-->(.|\n)*?<!--END EZ_WEB TEMP-->\n//gm;
$content =~ s/<!--START EZ_WEB HTML-->(.|\n)*?<!--END EZ_WEB HTML-->\n//gm;


$content = &headers::remove($content);
$content =~ s/<\/TEXTAREA>/<\%\%TEXTAREA>/ig;

&Account::header($lang::um1,"$files::manage?account=$Account::account\&session=$Account::session\&dir=$INPUT{'dir'}",$lang::uf18);

print <<EOF;

<script language="JavaScript">
function update() {
	previewArea.document.body.innerHTML = inputArea.value;
}
function copyValue(f) {
    document.editform.elements[0].value = inputArea.value;
}

</script>
</HEAD>
<BODY onload="inputArea.onkeyup()">
<font face=$font_face><B>$lang::uf20 <font color=$text_highlight>$file</FONT></B> - <font size=-2>($lang::uf19)</font><BR>
<iframe id=previewArea style="width: 95%; height: 45%;
							overflow: auto;">
</iframe><BR>
<font size=-2>$lang::uf21</font><BR>
<textarea name="" style="width:100%; height: 45%;" id="inputArea" onkeyup="update()" onkeydown="update()">$content</TEXTAREA>
<BR>

<FORM METHOD=POST ACTION="$files::files" name="editform">
<textarea name="filecontents" rows=0 cols=0 STYLE="display: none">
</TEXTAREA>

<INPUT TYPE="SUBMIT" NAME="edit_final" VALUE="$lang::uf21" onClick="copyValue(this);">
<input type="Hidden" name="dir" value="$INPUT{'dir'}">
<input type="Hidden" name="sfile" value="$INPUT{'sfile'}">
$Account::hidden_variables
</form>
EOF
&Account::footer;
exit;
}


########## EDIT FINAL #########
sub edit_final {

$file = $INPUT{'sfile'};

$error='';;

if ($file) {
	@filename=split(/\./,$file);
	$ext = "." . $filename[1];
	$ext ="\L$ext\E";
	$base_name = $filename[0];
	@out = split(//,$base_name);
	$a=0;
	foreach $char (@out) {
		$a++;	
		unless (($char =~ /[a-z]/) || ($char =~ /[A-Z]/) || ($char =~ /[0-9]/) || ($char =~ /_/)){
			$error .= "<font face=$font_face><B>$file -- $lang::uf23</B></font><BR></b>"; # Invalid File name
			last;
		}
	}
	unless ($a) {
		$error .= "<font face=$font_face><B>$lang::uf24</B></font><BR></b>"; # You must enter a file name
	}
	unless ($ext && ($good_types{$ext})) {
		$error .= "<font face=$font_face><B>$ext -- $lang::uf25</B></font><BR>"; # Invalid file type 
	}
	if ($error) {
		&Account::header($lang::um1,"$files::manage?account=$Account::account\&session=$Account::session\&dir=$INPUT{'dir'}",$lang::a13);
print <<EOF;
<BR>
<table cellpadding=5 border=1 cellspacing=0 bgcolor="#E0C2C2">
<TR><TD><font face=$font_face size=$font_size>
$lang::uf26<BR><BR>
$error
<BR>
$lang::uf27
</TD></TR></TABLE>
EOF
		&Account::footer;
		exit;
	}
}
else {
	&Account::header($lang::um1,"$files::manage?account=$Account::account\&session=$Account::session\&dir=$INPUT{'dir'}",$lang::a13);
print <<EOF;
<BR>
<table cellpadding=5 border=1 cellspacing=0 bgcolor="#E0C2C2">
<TR><TD><font face=$font_face size=$font_size>
$lang::uf28<BR><BR>
$lang::uf29
</TD></TR></TABLE>
EOF
	&Account::footer;
	exit;
}

unless (-e "$dir_plus/$file") {
	$Account::num_files++;
	if ($files_total && ($Account::num_files > $files_total)) {
		&Account::header($lang::um1,"$files::manage?account=$Account::account\&session=$Account::session\&dir=$INPUT{'dir'}",$lang::a13);
print <<EOF;
<BR>
<table cellpadding=5 border=1 cellspacing=0 bgcolor="#E0C2C2">
<TR><TD><font face=$font_face size=$font_size>
$lang::uf30 <B>$files_total</B>
</TD></TR></TABLE>
EOF
	&Account::footer;
	exit;
	}	
}

$start_body =0;
$end_body = 0;

$"='';

$content = $INPUT{'filecontents'};
$content =~ s/\r//g;

unless ($Account::hf_on) { $Account::hf_on = "on"; }

$head='';
$foot='';

undef $/;
if ($Account::file_header) {
	open (HEAD, "$main::path/$Account::file_header");
	$head = <HEAD>;
	close (HEAD);

	unless ($Account::file_header eq "header_html.txt") {
		$head =~ s/.*\n//;
	}
}

if ($Account::file_footer) {
	open (HEAD, "$main::path/$Account::file_footer");
	$foot = <HEAD>;
	close (HEAD);

	unless ($Account::file_footer eq "footer_html.txt") {
		$foot =~ s/.*\n//;
	}
}
$/="\n";

if ($Account::hf_on eq "off") {
	$head = '';
	$foot = '';
}

if ($good_types{$ext} eq "html") { 
	$content = &headers::remove($content);
	$new_content = &headers::add($content,$head,$foot);
}
else {
	$new_content = $content;
}

$new_content =~ s/<\%\%TEXTAREA>/<\/TEXTAREA>/ig;

$ok_upload = &Account::size_test("$dir_plus/$file",$new_content);

unless ($ok_upload) {
	print "Size toooo big";
	exit;
}

open (DAT,">$dir_plus/$file") || &Account::error("$lang::a9 - $dir_plus/$file");
print DAT "$new_content";
close (DAT);

&Account::log_it('4',$lang::uf32," ","$main::url_plus/$main::file");	
&Account::space_file_check;
&Account::print_account;

$" = ' ';

&Account::header($lang::um1);
print <<EOF;
<BR>
<font face=$font_face size=$font_size>
$lang::uf31
<BR><BR>

<B><A HREF="$files::ezweb?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}">$lang::uf33</A></B>

<BR><BR>
<B>
<A HREF="$files::manage?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}">$lang::uf34</A>
</B>
EOF
&Account::footer;
exit;

}


########## DELETE FILES ##########
sub delete {

if ($INPUT{'sfile'}) {
	@del_files = split(/\,/,$INPUT{'sfile'});
}
else {
	@del_files = $INPUT{'delete'};
	$INPUT{'sfile'} = $INPUT{'delete'};
}

unless ($INPUT{'sfile'}) {
	&Account::header("Error");
	print "$lang::uf35<BR>";
	&Account::footer;
	exit;
}	

$file = $INPUT{'sfile'};

if ($file =~ /\.\./) {
	&error("hacking attempt");
}


$message = "<font face=$font_face>$lang::uf36<BR><TABLE cellpadding=8 border=0>";
foreach $file(@del_files) {
$message .= "<TR><TD align=left><font face=$font_face><B>$file</B></font></TD></TR>";

unlink ("$dir_plus/$file");

}

$message .= "</TABLE>";

&Account::space_file_check;
&Account::print_account;
&Account::header($lang::uf47); # DELETED

print <<EOF;
$message
<BR><BR>
<B>
<A HREF="$files::manage?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}">$lang::uf34</A>
</B><BR><BR>
EOF
&Account::footer;
exit;
}


########### CREATE NEW FILE ##########
sub new {

&Account::header($lang::uf46);

print <<EOF; 
<TABLE width=400 cellspacing=0 cellpadding=0 border=0><TR><TD>
<font face=$font_face size=$font_size>
<B>$lang::uf37
</B><BR><BR>
<B>
<A HREF="$files::ez_web?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}">$lang::uf38</A></B> - $lang::uf39
<BR><BR>
EOF

if (-e "$path/templates") {
	opendir (DIR, "$path/templates") || &error("can not open $path");
	@temps = grep {(/^template\_[0-9]*\.dat/)}  readdir(DIR);
	close (DIR);
	
}
else {
	opendir (DIR, "$path") || &error("can not open $path");
	@temps = grep {(/^template\_[0-9]*\.dat/)}  readdir(DIR);
	close (DIR);
}

$num_temps = @temps;

if ($num_temps) {

print <<EOF;
<B><A HREF="$files::templates?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}">$lang::uf40</A></B> - 
$lang::uf41<BR><BR>
EOF

}

$textarea = "ROWS=20 COLS=45";

if ($Account::browser eq "IE") {
	$textarea = "ROWS=25 COLS=65";
}

print qq~

<font face=$font_face size=$font_size>
<B>$lang::uf42</B> -
$lang::uf43
</TD></TR>
</TABLE><BR><BR>
<script language="JavaScript">
<!--
function Preview() {
    var htmlWnd=window.open("","html","width=600,height=480,scrollbars=yes,resizable=yes,status=0");
    htmlWnd.document.open();
    htmlWnd.document.writeln(document.html.filecontents.value);
    htmlWnd.document.writeln('<BR><p><hr noshade width="100%"><a href="javascript:window.close()">Done - Close Window</a><BR><BR>');
    htmlWnd.document.close();
}
//-->
</SCRIPT>
<FORM METHOD=POST ACTION="$cgiurl" name="html">
$Account::hidden_variables
<INPUT TYPE=hidden name="dir" value="$INPUT{'dir'}">
<font face=$font_face size=$font_size><B>$lang::uf44</b></FONT> <INPUT TYPE="Text" NAME="sfile" VALUE="filename.html"></B>
<BR><BR>
<TEXTAREA NAME="filecontents" $textarea wrap="OFF">
</TEXTAREA>
<BR><BR>
<INPUT TYPE="SUBMIT" NAME="edit_final" VALUE=" $lang::uf45 ">
<font face=$font_face size=$font_size><SMALL>[<a href="javascript:void(0);" onClick="Preview()">preview html</a>]</SMALL></FONT>

</form>
~;

&Account::footer;
exit;

} 







## ERROR ##
sub error {
$error = shift;
print <<EOF;
ERROR = $error - $!
EOF
exit;
}

# Version/Other: 3.26
# Licensed to: Robert R FLower
# Downloaded on: 8/21/00, 9:11 p.m.
# IP Address: 24.64.143.114
# Session: JvNsWNqK

