#!/usr/bin/perl

# Version/Other: 3.26
# Licensed to: Robert R FLower
# Downloaded on: 8/21/00, 9:11 p.m.
# IP Address: 24.64.143.114
# Session: JvNsWNqK


#############################################
#                                           #
#                                           #
#        Home Free 3.26             #
#        Solution Scripts                   #
#        Copyright 1997-2000                #
#        http://solutionscripts.com         #
#                                           #
#                                           #
# Using, selling, distrubiting the code for #
# this program without prior written        #
# consent is expressly forbidden. In all    #
# cases all copyrights and downoad stamps   #
# MUST remain intact. Lots of time and      #
# energy has go into the creation of this   #
# program, please respect our work. Thanks  #
#                                           #
#                                           #
#############################################


$|=1;

BEGIN {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");
}

require "variables.pl";
require "dblib.pl";
require "acc_auth.pl";
require "header_footer.pl";

print "Content-type: text/html\n\n ";

&Account::initialize;

&Account::verify_user;

if ($INPUT{'tfghemplate'}) { &template; }
elsif ($INPUT{'preview'}) { &save_template; }
elsif ($INPUT{'save'}) { &save_template; }
elsif ($INPUT{'template'}) { &template; }
elsif ($INPUT{'file'}) { &template; }
elsif ($INPUT{'rename'}) { &rename; }
elsif ($INPUT{'rename_final'}) { &rename_final; }

elsif ($INPUT{'new'}) { &new; }

else { &main; }

sub main {

&Account::header($lang::ut1);

print <<EOF;
<TABLE width=400><TR><TD>
<font face=$font_face size=$font_size>
$lang::ut2
<BR><BR>
EOF

if (-e "$path/templates") {
	opendir (DIR, "$path/templates") || &error("can not open $path");
	@temps = grep {(/^template\_[0-9]*\.dat/)}  readdir(DIR);
	close (DIR);
	$t_path = "$path/templates";
	
}
else {
	opendir (DIR, "$path") || &error("can not open $path");
	@temps = grep {(/^template\_[0-9]*\.dat/)}  readdir(DIR);
	close (DIR);
	$t_path = $path
}

@tempnums = map { (my $num = $_) =~ s/\D//g; $num } @temps;
@tempnums = sort { $a <=> $b }@tempnums;

foreach (@tempnums) {
	$ttem = "template_" . $_ . ".dat";
	
	open (HEAD, "$t_path/$ttem");
	@ffil = <HEAD>;
	close (HEAD);

print <<EOF;
<B>
<A HREF="$files::templates?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}&template=$ttem">$ffil[0]</A>
</B> - $ffil[1]
<BR><BR>
EOF

}

print <<EOF;
</TD></TR>
</TABLE>
EOF

&Account::footer;
exit;
}


########## TEMPLATE ###########
sub template {

$dir = $INPUT{'dir'};
$dir =~ s/^\///;

if ($dir =~ /\.\./) { &error("hacking attempt"); }
if ($dir) { $dir_plus = "$Account::dir_acc/$dir"; }
else { $dir_plus = $Account::dir_acc; }

$template = $INPUT{'template'};
$template =~ s/\.\.//gi;


undef $/;
if (-e "$path/templates/$template") {
	open (HEAD, "$path/templates/$template");
	$ffil = <HEAD>;
	close (HEAD);
}
else {
	open (HEAD, "$path/$template");
	$ffil = <HEAD>;
	close (HEAD);
}


@afil = split(/\n/,$ffil);
$line1 = $afil[0];
$line2 = $afil[1];

if ($INPUT{'file'}) {

	open (HEAD, "$dir_plus/$INPUT{'file'}");
	$sfile = <HEAD>;
	close (HEAD);

	$sfile =~ s/<!--START EZ_WEB TEMP-->\n//gm;
	$sfile =~ s/<!--END EZ_WEB TEMP-->(.|\n)*//gm;	

	@asfile = split(/\n/,$sfile);
	
	foreach $line (@asfile) {
		@aline = split(/\%\%/,$line);
		$ffil =~ s/\%$aline[1]\%/$aline[2]/g;
	}		

	$ffil =~ s/\%.*\%//g;
}
else {

	$defalt = $ffil;
	$defalt =~ s/START_DEFAULTS\n//gm;
	$defalt =~ s/END_DEFAULTS(.|\n)*//gm;	

	$ffil =~ s/START_DEFAULTS(.|\n)*?END_DEFAULTS\n//m;

	@asfile = split(/\n/,$defalt);
	
	foreach $line (@asfile) {
		chomp($line);
		@aline = split(/\%\%/,$line);
		$ffil =~ s/\%$aline[0]\%/$aline[1]/g;
	}

	$ffil =~ s/\%.*\%//g;
}

$ffil =~ s/.*\n.*\n//m;

&Account::header($lang::ut1);

$dir_list = &Account::dir_select_list($dir);

print <<EOF;
<script language="JavaScript1.1">
<!--
function previewForm() {
	document.htmlForm.target="preview"
	document.htmlForm.submit
}
function saveForm() {
	document.htmlForm.target="_self"
	document.htmlForm.submit
}
//-->
</script>

<FORM METHOD=POST ACTION="$cgiurl" name="htmlForm">
$Account::hidden_variables
<TABLE border=0 cellpadding=5 width=500><TR>
<TD colspan=2 align=center>
<font face=$font_face size=$font_size>
<B>$line1</B><BR><BR>
</TD></TR>
<TR><TD>
<font face=$font_face size=$font_size>
$lang::ut3
</TD><TD>
<input type="Text" name="_file_name_" size="20" value="$INPUT{'file'}">
</TD></TR>
<TR><TD>
<font face=$font_face size=$font_size>
$lang::ut4
</TD>
<TD>
<SELECT NAME="dir">
<OPTION VALUE="">$lang::a10
$dir_list
</SELECT>
</TD></TR>
<TR><TD colspan=2>
<BR>
<HR NOSHADE SIZE=1 width=500>
</TD></TR>
</TABLE>

<BR><BR>
$ffil
<BR><BR>
<input type="Hidden" name="template" value="$template">
<input type="Submit" name="save" value = " $lang::ut5 " onClick="saveForm(this.form);">
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<input type="Submit" name="preview" value=" $lang::ut6 " onClick="previewForm(this.form);">
</FORM>
EOF
exit;
}

########## SAVE TEMPLATE ##########
sub save_template {

$template = $INPUT{'template'};

$ntemplate = $template;
$ntemplate =~ s/\.dat$//;

undef $/;

if (-e "$path/templates/$ntemplate.html") {
	open (HEAD, "$path/templates/$ntemplate.html");
	$file = <HEAD>;
	close (HEAD);
}
else {
	open (HEAD, "$path/$ntemplate.html");
	$file = <HEAD>;
	close (HEAD);
}

$hide ="<!--START EZ_WEB TEMP-->\n";
$hide .= "<!--\%\%template\%\%$template\%\%-->\n";
	
while ( ($key, $value) = each( %INPUT) ) {
	unless (($key eq "account") || ($key =~ /_[0-9]*\.dat/) || ($key eq "session") || ($key eq "dir") || ($key eq "_file_name_")) {
		$hide .= "<!--\%\%$key\%\%$value\%\%-->\n";
	}
	$file =~ s/\%$key\%/$value/gi;

}

$hide .= "<!--END EZ_WEB TEMP-->\n";

if ($INPUT{'save'}) {
	
	$html = $file;
#	&add_header;
	$file_name = $INPUT{'_file_name_'};
	@filsplit = split(/\./,$file_name);
	$filsplit[0] =~ s/![a-z|A-Z|0-9]//g;
	unless (($filsplit[1] eq "html") || ($filsplit[1] eq "htm") || ($filsplit[1] eq "shtml")) {
		&Account::header;
print <<EOF;
<BR>
<table cellpadding=5 border=1 cellspacing=0 bgcolor=$table_bg>
<TR><TD><font face=$font_face size=$font_size color=$text_table>
<B>$filsplit[0].$filsplit[1]</B> $lang::ut7
</TD></TR></TABLE>
EOF
		&Accounht::footer;
		exit;			
	}	
	$nfilen = "$filsplit[0].$filsplit[1]";

	if ($Account::hf_on eq "on") {
		
		undef $/;
		if ($Account::file_header) {
			open (HEAD, "$path/$Account::file_header");
			$hheader = <HEAD>;
			close (HEAD);
			
			if ($Account::file_header =~ "headers") {
				$hheader =~ s/.*\n//;
			}
		}
		
		if ($Account::file_footer) {
			open (HEAD, "$path/$Account::file_footer");
			$ffooter = <HEAD>;
			close (HEAD);
			
			if ($Account::file_footer =~ "footers") {
				$ffooter =~ s/.*\n//;
			}
		}		
		$/="\n";
			
		$content = &headers::add($html,$hheader,$ffooter);
	}
	else {
		$content = $html;
	}


	open (HEAD, ">$dir_plus/$nfilen") || print("writing $dir_plus/$nfilen $!");
	print HEAD "$hide";
	print HEAD "$content";
	close (HEAD);
	
&Account::header("Template");
print <<EOF;
<BR>
<font face=$font_face size=$font_size>
$lang::ut8
<BR><BR>
<B><A HREF="$files::templates?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}">$lang::ut9</A></B>
<BR><BR>
<B>
<A HREF="$files::manage?account=$Account::cata_acc&session=$Account::session&dir=$INPUT{'dir'}">$lang::ut10</A>
</B>
EOF
&Account::footer;
exit;
}
else {
	#### PRINT PREVIEW ####
	print "$file";
}
exit;
}


1;

# Version/Other: 3.26
# Licensed to: Robert R FLower
# Downloaded on: 8/21/00, 9:11 p.m.
# IP Address: 24.64.143.114
# Session: JvNsWNqK

