#!/usr/bin/perl

# Version/Other: 3.26
# Licensed to: Robert R FLower
# Downloaded on: 8/21/00, 9:11 p.m.
# IP Address: 24.64.143.114
# Session: JvNsWNqK


#############################################
#                                           #
#                                           #
#        Home Free 3.26             #
#        Solution Scripts                   #
#        Copyright 1997-2000                #
#        http://solutionscripts.com         #
#                                           #
#                                           #
# Using, selling, distrubiting the code for #
# this program without prior written        #
# consent is expressly forbidden. In all    #
# cases all copyrights and downoad stamps   #
# MUST remain intact. Lots of time and      #
# energy has go into the creation of this   #
# program, please respect our work. Thanks  #
#                                           #
#                                           #
#############################################



$|=1;

BEGIN {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");
}

require "variables.pl";
require "acc_auth.pl";
require "dblib.pl";
require "header_footer.pl";

unless ($INPUT{'wwwboard'}) {
	print "Content-type: text/html\n\n ";
	&Account::initialize;
}

if ($INPUT{'wwwboard'}) {

	$account = $INPUT{'wwwboard'};
	$INPUT{'account'} = $INPUT{'wwwboard'};


	$cata = $main::INPUT{'cata'};

	unless ($cata) { $cata="accounts"; }

	$Account::account = $account;
	$Account::cata = $cata;
	
	&Account::get_account;
	&Account::get_base_path;
}
else {
	if ($ENV{'SCRIPT_NAME'} =~ /features/) { return(1); }	
	&Account::verify_user;
}

$basedir = "$dir_plus/wwwboard";
$baseurl = "$url_plus/wwwboard";
$mesgdir = "";
$datafile = "data.txt";
$mesgfile = "index.html";
$faqfile = "faq.html";
$ext = "html";
$title = $Account::www_name;
$use_time = 1;		# 1 = YES; 0 = NO	


$int =1000;
srand();
$rand_num = rand();
$rand_num = int($rand_num * $int); 
$rands = $rand_num + $time;


if ($INPUT{'wwwboard'}) { &wwwboard; }
elsif ($INPUT{'save_temp'}) { &save_temp; }
elsif ($INPUT{'wwwboard_admin'}) { &wwwboard_admin; }	
	
	
	
if ($INPUT{'edit_wwwboard'}) { &edit_wwwboard; }
elsif ($INPUT{'action'} eq "admin") { &www_board_admin; }
elsif ($INPUT{'action'} eq "wwwboard") { &www_board; }
elsif ($INPUT{'www_board_delete'}) { &www_board_delete; }
exit;

sub www_board {

my $message = $_[0];

	open (HEAD, "$Account::dir_acc/wwwboard/board.dat");
	@datas = <HEAD>;
	close (HEAD);
	
	$datas[10] =~ s/\\n/\n/g;
	$datas[11] =~ s/\\n/\n/g;

	$num_posts = 0;

	opendir (DIR, "$Account::dir_acc/wwwboard");
	@files = grep {!(/^\./)}  readdir(DIR);
	close (DIR); 

	$num_posts = push(@files);

	if ($num_posts > 3) {
		$num_posts = $num_posts - 3;
	}
	$out_of = "";
	if ($wwwboard_num) {
		$out_of = "$lang::w2 $wwwboard_num ";
	}

&Account::header($lang::w1);
print <<EOF;
<font face=$font_face size=$font_size><B>$message
<FORM METHOD=POST ACTION="$cgiurl">
$Account::hidden_variables
$lang::w4</B><BR><BR>
<table width=450><TD><TR>
<font face=$font_face size=$font_size>
$lang::w5
<a href="$url_plus/wwwboard/index.html">$url_plus/wwwboard/index.html</a>,
$lang::w6
<BR><BR>
</TD></TR></TABLE>

<table cellpadding=5 border=1 cellspacing=0 bgcolor=$table_bg>
<TR><TD bgcolor=$table_head_bg align=center colspan=2>
<font color=$text_table_head face=$font_face size=$font_size>
$lang::w7
</TD></TR>
<TR><TD><font color=$text_table face=$font_face size=$font_size>
$lang::w8 $out_of
</TD><TD>
<font color=$text_table face=$font_face size=$font_size>
&nbsp;&nbsp;$num_posts</TD></TR>
<TR><TD><font color=$text_table face=$font_face size=$font_size>
$lang::w9
</TD><TD>
<font color=$text_table face=$font_face size=$font_size>
<input type="Text" name="wwwboard_name" value="$Account::www_name" size="20"></TD></TR>
<TR><TD><font color=$text_table face=$font_face size=$font_size>
$lang::w10
</TD><TD>
<input type="Text" name="g_bgcolor" value="$datas[1]">
</TD></TR>
<TR><TD><font color=$text_table face=$font_face size=$font_size>
$lang::w11
</TD><TD>
<input type="Text" name="g_bgimage" value="$datas[2]">
</TD></TR>
<TR><TD><font color=$text_table face=$font_face size=$font_size>
$lang::w12
</TD><TD>
<input type="Text" name="g_text" value="$datas[3]">
</TD></TR>
<TR><TD><font color=$text_table face=$font_face size=$font_size>
$lang::w13
</TD><TD>
<input type="Text" name="g_link" value="$datas[4]">
</TD></TR>
<TR><TD><font color=$text_table face=$font_face size=$font_size>
$lang::w14
</TD><TD>
<input type="Text" name="g_vlink"  value="$datas[5]">
</TD></TR>
<TR><TD colspan=2><font color=$text_table face=$font_face size=$font_size>
$lang::w15
</TD></TR>
<TR><TD colspan=2>
<textarea name="g_head" cols="35" rows="8" wrap="OFF">$datas[10]</textarea>
</TD></TR>
<TR><TD colspan=2><font color=$text_table face=$font_face size=$font_size>
$lang::w16
</TD></TR>
<TR><TD colspan=2>
<textarea name="g_foot" cols="35" rows="8" wrap="OFF">$datas[11]</textarea>
</TD></TR>
<TR><TD colspan=2 align=center>
<input type="Submit" name="edit_wwwboard" value="$lang::w17">
</TD></TR>
</TABLE></FORM>
<BR><BR>

<table cellpadding=5 border=1 cellspacing=0 bgcolor=$table_bg>
<TR><TD bgcolor=$table_head_bg align=center colspan=2>
<form action="$files::wwwboard" method="POST">
<input type="Hidden" name="wwwboard_admin" value="$Account::account">
$Account::hidden_variables

<font color=$text_table_head face=$font_face size=$font_size>
$lang::w18
</TD></TR>
<TR><TD>
<font color=$text_table face=$font_face size=$font_size>
$lang::w19
</TD><TD>
<font color=$text_table face=$font_face size=$font_size>
$lang::w20&nbsp;&nbsp;
<select name="command">
<option value="remove">$lang::w21
<option value="remove_by_num">$lang::w22
<option value="remove_by_date">$lang::w23
<option value="remove_by_author">$lang::w24
</select>
&nbsp;&nbsp;<input type="Submit" name="" value="$lang::w25">
</TABLE>
</FORM>
<blockquote>
$lang::w26
</BLOCKQUOTE>
EOF
&Account::footer;
exit;
}

########### EDIT SETTINGS ###########
sub edit_wwwboard {

mkdir("$Account::dir_acc/wwwboard", 0777);
chmod(0777,"$Account::dir_acc/wwwboard");

open (VAR, ">$Account::dir_acc/wwwboard/board.dat");
print VAR "0\n";
print VAR "$INPUT{'g_bgcolor'}\n";
print VAR "$INPUT{'g_bgimage'}\n";
print VAR "$INPUT{'g_text'}\n";
print VAR "$INPUT{'g_link'}\n";
print VAR "$INPUT{'g_vlink'}\n";
print VAR "0\n";
print VAR "0\n";
print VAR "0\n";
print VAR "0\n";
$INPUT{'g_head'} =~ s/\r//g;
$INPUT{'g_foot'} =~ s/\r//g;
$g_head = $INPUT{'g_head'};
$g_foot = $INPUT{'g_foot'};
$INPUT{'g_head'} =~ s/\n/\\n/g;
$INPUT{'g_foot'} =~ s/\n/\\n/g;

print VAR "$INPUT{'g_head'}\n";
print VAR "$INPUT{'g_foot'}\n";
close (VAR);	


	$Account::www_name = $INPUT{'wwwboard_name'};
	&Account::print_account;

	undef $/;
	open (VARIABLES, "$Account::dir_acc/wwwboard/index.html");
	$forum = <VARIABLES>;
	close (VARIABLES);
	$/="\n";
	
	$forum =~ s/(.|\n)*?<!--begin-->//m;
	$forum =~ s/<!-- END POSTS -->(.|\n)*//m;

	unless ($forum) { $forum = "\n<\ul>\n"; }

	undef $/;

	if ($wwwboard_header) {
		open (HEAD, "$main::path/wwwboard_header.txt");
		$ahead = <HEAD>;
		close (HEAD);
	}	
	elsif ($Account::file_header) {
		open (HEAD, "$main::path/$Account::file_header");
		$ahead = <HEAD>;
		close (HEAD);
		unless ($Account::file_header eq "header_html.txt") {
			$ahead =~ s/.*\n//;
		}	
	}
	if ($wwwboard_header) {
		open (HEAD, "$main::path/wwwboard_footer.txt");	
		$afoot = <HEAD>;
		close (HEAD);
	}
	elsif ($Account::file_footer) {

		open (HEAD, "$main::path/$Account::file_footer");
		$afoot = <HEAD>;
		close (HEAD);
	
		unless ($Account::file_footer eq "footer_html.txt") {
		$afoot =~ s/.*\n//;
		}	
	}
	$/="\n";

	if ($Account::hf_on eq "off") {
		$ahead= '';
		$afoot = '';
	}

	$header = "\n$start_head";
	$header .="$ahead\n";
	$header .= "$end_head";
	
	$footer = "\n$start_foot";
	$footer .="$afoot\n";
	$footer .= "$end_foot";


	open (WEB, ">$Account::dir_acc/wwwboard/index.html");
	print WEB "<html><head>\n";
	print WEB "<TITLE>$INPUT{'wwwboard_name'}</TITLE></HEAD>\n";
	print WEB "<BODY";
	if ($INPUT{'g_bgimage'}) { print WEB " background=\"$INPUT{'g_bgimage'}\""; }
	if ($INPUT{'g_bgcolor'}) { print WEB " bgcolor=\"$INPUT{'g_bgcolor'}\""; }
	if ($INPUT{'g_text'}) { print WEB " text=\"$INPUT{'g_text'}\""; }
	if ($INPUT{'g_link'}) { print WEB " link=\"$INPUT{'g_link'}\""; }
	if ($INPUT{'g_vlink'}) { print WEB " vlink=\"$INPUT{'g_vlink'}\""; }
	print WEB ">\n\n";
	print WEB $header;
	print WEB $g_head;
	print WEB "<center><font face=arial size=-1><B><font size=+1>\n";
	print WEB "$INPUT{'wwwboard_name'}\n";
	print WEB "</B></FONT></center>\n";
	print WEB "<hr size=1 noshade width=50%>\n";
	print WEB "<center><a href=\"\#post\">$lang::w27</a></center>\n";
	print WEB "<hr size=1 noshade width=50\%>\n";
	print WEB "<CENTER><TABLE BORDER=0><TR><TD><font face=arial size=-1>\n";
	print WEB "<ul>\n";
	print WEB "<!--begin-->";
	print WEB $forum;
	print WEB "<!-- END POSTS -->\n";
	print WEB "<a name=\"post\"><center><font size=+1><B>$lang::w28</b></FONT></center></a>\n";
	print WEB "<form method=POST action=\"$files::wwwboard\">\n";
	print WEB "<input type=\"Hidden\" name=\"cata\" value=\"$Account::cata\">\n";
	print WEB "<input type=\"Hidden\" name=\"wwwboard\" value=\"$Account::account\">\n";
	print WEB "$lang::w29 <input type=text name=\"name\" size=30><br>\n";
	print WEB "$lang::w30 <input type=text name=\"email\" size=30><p>\n";
	print WEB "$lang::w31 <input type=text name=\"subject\" size=30><p>\n";
	print WEB "$lang::w32<br>\n";
	print WEB "<textarea COLS=55 ROWS=10 name=\"body\"></textarea><p>\n";
	print WEB "$lang::w33 <input type=text name=\"url\" size=30><br>\n";
	print WEB "$lang::w34 <input type=text name=\"url_title\" size=30><br>\n";
	print WEB "$lang::w35 <input type=text name=\"img\" size=30><p>\n";
	print WEB "<input type=submit value=\"$lang::w27\"> <input type=reset>\n";
	print WEB "</form></TD></TR></TABLE></CENTER>\n";
	print WEB $g_foot;
	print WEB $footer;
	print WEB "</BODY></HTML>\n";
	close (WEB);	

&www_board("Web Board info updated");
}


########## Web Board 2.0 ##########

sub wwwboard {

$show_faq = 0;		# 1 - YES; 0 = NO
$allow_html = 0;	# 1 = YES; 0 = NO
$quote_text = 1;	# 1 = YES; 0 = NO
$subject_line = 0;	# 0 = Quote Subject Editable; 1 = Quote Subject 
			#   UnEditable; 2 = Don't Quote Subject, Editable.

# Check amount of posts

$num_posts = 0;

opendir (DIR, "$Account::dir_acc/wwwboard");
@files = grep {!(/^\./)}  readdir(DIR);
close (DIR); 

$num_posts = push(@files);

if ($num_posts > 3) {
	$num_posts = $num_posts - 3;
}
if ($wwwboard_num && ($num_posts >= $wwwboard_num)) {
print <<EOF;
<table cellpadding=5 border=1 cellspacing=0 bgcolor=$table_bg>
<TR><TD align=center>
<font color=$text_table face=$font_face size=$font_size>
$lang::w36
</TD></TR></TABLE><BR>
EOF
	&user_footer;
	exit;	
}

# Get the Data Number
&get_number;
# Put items into nice variables
&get_variables;
# Open the new file and write inINPUTation to it.
&new_file;
# Open the Main WWWBoard File to add link
&main_page;
# Now Add Thread to Individual Pages
if ($num_followups >= 1) {
   &thread_pages;
}
# Return the user HTML
&return_html;
# Increment Number
&increment_num;
}
############################
# Get Data Number Subroutine


  sub get_number {
     open(NUMBER,"$basedir/$datafile");
    my($n) = <NUMBER>;
    $n =~ /(\d+)/;
    $num = $1;
     close(NUMBER);
     if ($num == 99999)  {
        $num = "1";
   }
   else {
      $num++;
   }
}

###############
# Get Variables

sub get_variables {

     if ($INPUT{'followup'}) {
        $followup = "1";
       my($item);
       my(@list) = split(/,/,$INPUT{'followup'});
       @followup_num = ();
       foreach $item (@list) {
         $item =~ /(\d+)/;
         push(@followup_num,$1);
         }
        $num_followups = @followups = @followup_num;
        $last_message = pop(@followups);
        $origdate = "$INPUT{'origdate'}";
   }
   else {
      $followup = "0";
   }

   if ($INPUT{'name'}) {
      $name = "$INPUT{'name'}";
      $name =~ s/"//g;
      $name =~ s/<//g;
      $name =~ s/>//g;
      $name =~ s/\&//g;
   }
   else {
      &wwwboard_error(no_name);
   }

   if ($INPUT{'email'} =~ /.*\@.*\..*/) {
      $email = "$INPUT{'email'}";
   }

   if ($INPUT{'subject'}) {
      $subject = "$INPUT{'subject'}";
      $subject =~ s/\&/\&amp\;/g;
      $subject =~ s/"/\&quot\;/g;
   }
   else {
      &wwwboard_error(no_subject);
   }

   if ($INPUT{'url'} =~ /.*\:.*\..*/ && $INPUT{'url_title'}) {
      $message_url = "$INPUT{'url'}";
      $message_url_title = "$INPUT{'url_title'}";
   }

   if ($INPUT{'img'} =~ /.*tp:\/\/.*\..*/) {
      $message_img = "$INPUT{'img'}";
   }

   if ($INPUT{'body'}) {
      $body = "$INPUT{'body'}";
      $body =~ s/\cM//g;
      $body =~ s/\n\n/<p>/g;
      $body =~ s/\n/<br>/g;

      $body =~ s/&lt;/</g; 
      $body =~ s/&gt;/>/g; 
      $body =~ s/&quot;/"/g;
   }
   else {
      &error(no_body);
   }

   if ($quote_text == 1) {
      $hidden_body = "$body";
      $hidden_body =~ s/</&lt;/g;
      $hidden_body =~ s/>/&gt;/g;
      $hidden_body =~ s/"/&quot;/g;
   }

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

   if ($sec < 10) {
      $sec = "0$sec";
   }
   if ($min < 10) {
      $min = "0$min";
   }
   if ($hour < 10) {
      $hour = "0$hour";
   }
   if ($mon < 10) {
      $mon = "0$mon";
   }
   if ($mday < 10) {
      $mday = "0$mday";
   }

   $month = ($mon + 1);

	$year += 1900;
	$yyear = $year;
	$yyear =~ s/^.{2}//;

   if ($use_time == 1) {
      $date = "$hour\:$min\:$sec $month/$mday/$yyear";
   }
   else {
      $date = "$month/$mday/$yyear";
   }
   chop($date) if ($date =~ /\n$/);

   $long_date = "$months[$mon] $mday, $year at $hour\:$min\:$sec";
}      

#####################
# New File Subroutine

sub new_file {

open (HEAD, "$basedir/board.dat");
@datas = <HEAD>;
close (HEAD);

foreach $line(@datas) {
	chomp($line);
}

$datas[10] =~ s/\\n/\n/g;
$datas[11] =~ s/\\n/\n/g;



	undef $/;

	if ($wwwboard_header) {
		open (HEAD, "$main::path/wwwboard_header.txt");
		$ahead = <HEAD>;
		close (HEAD);
	}	
	elsif ($Account::file_header) {
		open (HEAD, "$main::path/$Account::file_header");
		$ahead = <HEAD>;
		close (HEAD);
		unless ($Account::file_header eq "header_html.txt") {
			$ahead =~ s/.*\n//;
		}	
	}
	if ($wwwboard_header) {
		open (HEAD, "$main::path/wwwboard_footer.txt");	
		$afoot = <HEAD>;
		close (HEAD);
	}
	elsif ($Account::file_footer) {

		open (HEAD, "$main::path/$Account::file_footer");
		$afoot = <HEAD>;
		close (HEAD);
	
		unless ($Account::file_footer eq "footer_html.txt") {
		$afoot =~ s/.*\n//;
		}	
	}
	$/="\n";

	if ($Account::hf_on eq "off") {
		$ahead= '';
		$afoot = '';
	}

	$header = "\n$start_head";
	$header .="$ahead\n";
	$header .= "$end_head";
	
	$footer = "\n$start_foot";
	$footer .="$afoot\n";
	$footer .= "$end_foot";


open(NEWFILE,">$basedir/$num\.$ext") || &error("Error opening new file");
print NEWFILE "<html>\n";
print NEWFILE "  <head>\n";
print NEWFILE "    <title>$subject</title>\n";
print NEWFILE "  </head>\n";
print NEWFILE "<BODY";
if ($datas[2]) { print NEWFILE " background=\"$datas[2]\""; }
if ($datas[1]) { print NEWFILE " bgcolor=\"$datas[1]\""; }
if ($datas[3]) { print NEWFILE " text=\"$datas[3]\""; }
if ($datas[4]) { print NEWFILE " link=\"$datas[4]\""; }
if ($datas[5]) { print NEWFILE " vlink=\"$datas[5]\""; }
print NEWFILE ">\n\n";
print NEWFILE $header;
print NEWFILE $datas[10];
print NEWFILE "\n<font face=arial size=-1><center>\n";
print NEWFILE "      <b>$subject</b>\n";
print NEWFILE "    </center>\n";
print NEWFILE "<hr size=1 noshade width=75%>\n";
print NEWFILE "<center>[ <a href=\"#followups\">$lang::w37</a> ] [ <a href=\"#postfp\">$lang::w38</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
print NEWFILE "<hr size=1 noshade width=75%><p>\n";
print NEWFILE "<CENTER><TABLE BORDER=0><TR><TD><font face=arial size=-1>\n";
print NEWFILE "$lang::w39 ";
if ($email) {
	print NEWFILE "<a href=\"mailto:$email\">$name</a> $lang::w40 $long_date:<p>\n";
}
else {
	print NEWFILE "$name $lang::w40 $long_date:<p>\n";
}

if ($followup == 1) {
	print NEWFILE "$lang::w41 <a href=\"$last_message\.$ext\">$origsubject</a> $lang::w39 ";
	if ($origemail) {
		print NEWFILE "<a href=\"$origemail\">$origname</a> $lang::w40 $origdate:<p>\n";
    }
      else {
         print NEWFILE "$origname $lang::w40 $origdate:<p>\n";
      }
   }

   if ($message_img) {
      print NEWFILE "<center><img src=\"$message_img\"></center><p>\n";
   }
   print NEWFILE "$body\n";
   print NEWFILE "<br>\n";
   if ($message_url) {
      print NEWFILE "<ul><li><a href=\"$message_url\">$message_url_title</a></ul>\n";
   }
   print NEWFILE "<br><hr size=1 noshade width=75%><p>\n";
   print NEWFILE "<a name=\"followups\">$lang::w37</a><br>\n";
   print NEWFILE "<ul><!--insert: $num-->\n";
   print NEWFILE "</ul><!--end: $num-->\n";
   print NEWFILE "<br><hr size=1 noshade width=75%><p>\n";
   print NEWFILE "<a name=\"postfp\">$lang::w38</a><p>\n";
   print NEWFILE "<FORM method=POST action=\"$cgiurl\">\n";
   print NEWFILE "<input type=hidden name=\"cata\" value=\"$cata\">\n";
   print NEWFILE "<input type=hidden name=\"wwwboard\" value=\"$account\">\n";
   print NEWFILE "<input type=hidden name=\"followup\" value=\"";
   if ($followup == 1) {
      foreach $followup_num (@followup_num) {
         print NEWFILE "$followup_num,";
      }
   }
   print NEWFILE "$num\">\n";
   print NEWFILE "<input type=hidden name=\"origname\" value=\"$name\">\n";
   if ($email) {
      print NEWFILE "<input type=hidden name=\"origemail\" value=\"$email\">\n";
   }
   print NEWFILE "<input type=hidden name=\"origsubject\" value=\"$subject\">\n";
   print NEWFILE "<input type=hidden name=\"origdate\" value=\"$long_date\">\n";
   print NEWFILE "$lang::w29 <input type=text name=\"name\" size=30><br>\n";
   print NEWFILE "$lang::w30 <input type=text name=\"email\" size=30><p>\n";
   if ($subject_line == 1) {
      if ($subject_line =~ /^Re:/) {
         print NEWFILE "<input type=hidden name=\"subject\" value=\"$subject\">\n";
         print NEWFILE "$lang::w31 <b>$subject</b><p>\n";
      }
      else {
         print NEWFILE "<input type=hidden name=\"subject\" value=\"Re: $subject\">\n";
         print NEWFILE "$lang::w31 <b>Re: $subject</b><p>\n";
      }
   } 
   elsif ($subject_line == 2) {
      print NEWFILE "$lang::w31 <input type=text name=\"subject\" size=30><p>\n";
   }
   else {
      if ($subject =~ /^Re:/) {
         print NEWFILE "$lang::w31 <input type=text name=\"subject\"value=\"$subject\" size=30><p>\n";
      }
      else {
         print NEWFILE "$lang::w31 <input type=text name=\"subject\" value=\"Re: $subject\" size=30><p>\n";
      }
   }
   print NEWFILE "$lang::w32<br>\n";
   print NEWFILE "<textarea name=\"body\" COLS=50 ROWS=10>\n";
   if ($quote_text == 1) {
      @chunks_of_body = split(/\&lt\;p\&gt\;/,$hidden_body);
      foreach $chunk_of_body (@chunks_of_body) {
         @lines_of_body = split(/\&lt\;br\&gt\;/,$chunk_of_body);
         foreach $line_of_body (@lines_of_body) {
            print NEWFILE ": $line_of_body\n";
         }
         print NEWFILE "\n";
      }
   }
   print NEWFILE "</textarea>\n";
   print NEWFILE "<p>\n";
   print NEWFILE "$lang::w33 <input type=text name=\"url\" size=30><br>\n";
   print NEWFILE "$lang::w34 <input type=text name=\"url_title\" size=30><br>\n";
   print NEWFILE "$lang::w35 <input type=text name=\"img\" size=30><p>\n";
   print NEWFILE "<input type=submit value=\"$lang::w42\"> <input type=reset>\n";
   print NEWFILE "</FORM></TD></TR></TABLE><hr size=1 noshade width=75%>\n";
   if ($show_faq == 1) {
      print NEWFILE "<center>[ <a href=\"#followups\">$lang::w37</a> ] [ <a href=\"#postfp\">$lang::w38</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ] [ <a href=\"$baseurl/$faqfile\">FAQ</a> ]</center>\n";
   }
   else {
      print NEWFILE "<center>[ <a href=\"#followups\">$lang::w37</a> ] [ <a href=\"#postfp\">$lang::w38</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
   }
print NEWLINE $g_foot;
print NEWFILE $footer;
   print NEWFILE "</body></html>\n";
   close(NEWFILE);
   
   	@stats = stat("$basedir/$num\.$ext");
	$size = $stats[7];
	$size = $size /1000;
	$t_size = $size + $acco[3];
	$total_size += $acco[6];

	if (($t_size > $total_size) && $wwwboard_size) {
		unlink ("$basedir/$num\.$ext");
		 
print <<EOF;
<table cellpadding=5 border=1 cellspacing=0 bgcolor=$table_bg>
<TR><TD align=center>
<font color=$text_table face=$font_face size=$font_size>
$lang::w43
</TD></TR></TABLE><BR>
EOF

&user_footer;
		exit;	

	}
}

###############################
# Main WWWBoard Page Subroutine

sub main_page {
   open(MAIN,"$basedir/$mesgfile") || &error("open $basedir/$mesgfile");
   @main = <MAIN>;
   close(MAIN);

   open(MAIN,">$basedir/$mesgfile") || &error("write $basedir/$mesgfile");
   if ($followup == 0) {
      foreach $main_line (@main) {
         if ($main_line =~ /<!--begin-->/) {
            print MAIN "<!--begin-->\n";
	    print MAIN "<!--top: $num--><li><a href=\"$num\.$ext\">$subject</a> - <b>$name</b> <i>$date</i>\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   else {
      foreach $main_line (@main) {
	 $work = 0;
         if ($main_line =~ /<ul><!--insert: $last_message-->/) {
            print MAIN "<ul><!--insert: $last_message-->\n";
            print MAIN "<!--top: $num--><li><a href=\"$num\.$ext\">$subject</a> - <b>$name</b> <i>$date</i>\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         elsif ($main_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print MAIN "(<!--responses: $followup_num-->$num_responses)\n";
		  $work = 1;
               }
            }
            if ($work != 1) {
               print MAIN "$main_line";
            }
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   close(MAIN);
}

############################################
# Add Followup Threading to Individual Pages
sub thread_pages {

   foreach $followup_num (@followup_num) {
      open(FOLLOWUP,"$basedir/$followup_num\.$ext");
      @followup_lines = <FOLLOWUP>;
      close(FOLLOWUP);

      open(FOLLOWUP,">$basedir/$followup_num\.$ext");
      foreach $followup_line (@followup_lines) {
         $work = 0;
         if ($followup_line =~ /<ul><!--insert: $last_message-->/) {
	    print FOLLOWUP "<ul><!--insert: $last_message-->\n";
            print FOLLOWUP "<!--top: $num--><li><a href=\"$num\.$ext\">$subject</a> <b>$name</b> <i>$date</i>\n";
            print FOLLOWUP "(<!--responses: $num-->0)\n";
            print FOLLOWUP "<ul><!--insert: $num-->\n";
            print FOLLOWUP "</ul><!--end: $num-->\n";
         }
         elsif ($followup_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print FOLLOWUP "(<!--responses: $followup_num-->$num_responses)\n";
                  $work = 1;
               }
            }
            if ($work != 1) {
               print FOLLOWUP "$followup_line";
            }
         }
         else {
            print FOLLOWUP "$followup_line";
         }
      }
      close(FOLLOWUP);
   }
}

sub return_html {
   &user_header;
   print "<body bgcolor=white text=black link=blue vlink=blue alink=blue><font face=arial size=-1><center><B>$lang::w44 $subject</b></center>\n";
   print "<br><br>$lang::w46<p><hr size=1 noshade width=75%><p>\n";
   print "<TABLE BORDER=0><TR><TD><font face=arial size=-1>\n";
   print "<b>$lang::w29</b> $name<br>\n";
   print "<b>$lang::w30</b> $email<br>\n";
   print "<b>$lang::w31</b> $subject<br>\n";
   print "<b>$lang::w32</b><p>\n";
   print "$body<p>\n";
   if ($message_url) {
      print "<b>$lang::w33</b> <a href=\"$message_url\">$message_url_title</a><br>\n";
   }
   if ($message_img) {
      print "<b>$lang::w35</b> <img src=\"$message_img\"><br>\n";
   }
   print "<b>$lang::w45</b> $date<p>\n";
   print "</TD></TR></TABLE><hr size=1 noshade width=75%>\n";
   print "<center>[ <a href=\"$baseurl/$num\.$ext\">$lang::47</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
	&user_footer;
}

sub increment_num {
   open(NUM,">$basedir/$datafile") || die $!;
   print NUM "$num";
   close(NUM);
}

sub wwwboard_error {
   $error = $_[0];

   if ($error eq 'no_name') {
   &user_header;
      print "<body bgcolor=white text=black link=blue vlink=blue alink=blue><font face=arial size=-1><center><B>ERROR: No Name</b></center>\n";
      print "<br><br>$lang::w48<p><hr size=1 noshade width=75%><p>\n";
      &rest_of_INPUT;
   }
   elsif ($error eq 'no_subject') {
      &user_header;
      print "<body bgcolor=white text=black link=blue vlink=blue alink=blue><font face=arial size=-1><center><B>ERROR: No Subject</b></center>\n";
      print "<br><br>$lang::w48<p><hr size=1 noshade width=75%><p>\n";
      &rest_of_INPUT;
   }
   elsif ($error eq 'no_body') {
      &user_header;
      print "<body bgcolor=white text=black link=blue vlink=blue alink=blue><font face=arial size=-1><center><B>ERROR: No Message</b></center>\n";
      print "<br><br>$lang::w48<p><hr size=1 noshade width=75%><p>\n";
      &rest_of_INPUT;
   }
   else {
      print "ERROR!  Undefined.\n";
   }
   exit;
}

sub rest_of_INPUT {

   print "</CENTER><FORM method=POST action=\"$cgiurl\">\n";
   print "<input type=hidden name=\"cata\" value=\"$cata\">\n";
   print "<input type=hidden name=\"wwwboard\" value=\"$account\">\n";
   if ($followup == 1) {
      print "<input type=hidden name=\"origsubject\" value=\"$INPUT{'origsubject'}\">\n";
      print "<input type=hidden name=\"origname\" value=\"$INPUT{'origname'}\">\n";
      print "<input type=hidden name=\"origemail\" value=\"$INPUT{'origemail'}\">\n";
      print "<input type=hidden name=\"origdate\" value=\"$INPUT{'origdate'}\">\n";
      print "<input type=hidden name=\"followup\" value=\"$INPUT{'followup'}\">\n";
   }
   print "$lang::w29 <input type=text name=\"name\" value=\"$INPUT{'name'}\" size=50><br>\n";
   print "$lang::w30 <input type=text name=\"email\" value=\"$INPUT{'email'}\" size=50><p>\n";
   if ($subject_line == 1) {
      print "<input type=hidden name=\"subject\" value=\"$INPUT{'subject'}\">\n";
      print "$lang::w31 <b>$INPUT{'subject'}</b><p>\n";
   } 
   else {
      print "$lang::w31 <input type=text name=\"subject\" value=\"$INPUT{'subject'}\" size=50><p>\n";
   }
   print "$lang::w32<br>\n";
   print "<textarea COLS=50 ROWS=10 name=\"body\">\n";
   $INPUT{'body'} =~ s/</&lt;/g;
   $INPUT{'body'} =~ s/>/&gt;/g;
   $INPUT{'body'} =~ s/"/&quot;/g;
   print "$INPUT{'body'}\n";
   print "</textarea><p>\n";
   print "$lang::w33 <input type=text name=\"url\" value=\"$INPUT{'url'}\" size=45><br>\n";
   print "$lang::w34 <input type=text name=\"url_title\" value=\"$INPUT{'url_title'}\" size=50><br>\n";
   print "$lang::w35 <input type=text name=\"img\" value=\"$INPUT{'img'}\" size=45><p>\n";
   print "<input type=submit value=\"$lang::w27\"> <input type=reset>\n";
   print "</FORM>\n";
	&user_footer(1);

}










########## WEB BOARD 2.0 ADMIN ##########
sub wwwboard_admin {


$command = $INPUT{'command'}; 

if ($command eq 'remove') {
	
   &Account::header($lang::w1,'',$lang::w49);
   print "<font face=$font_face size=$font_size><B>$lang::w50</b></font><BR>\n";
   print "<table border=0 width=80%><TR align=center><TD><font face=$font_face size=$font_size>$lang::w51";
   print "</font></TD></TR></TABLE>\n";
   print "<hr size=1 noshade width=75%><center><font size=$font_size>\n";
   print "<form method=POST action=\"$cgiurl\">\n";
   print "<input type=hidden name=\"wwwboard_admin\" value=\"submit\">\n";
   print "$Account::hidden_variables\n";
   print "<input type=hidden name=\"action\" value=\"remove\">\n";
   print "<center><table border=1 cellpadding=4 cellspacing=1 bgcolor=$table_bg>\n";
   print "<tr bgcolor=$table_head_bg>\n";
   print "<th><font face=$font_face size=$font_size color=$text_table_head>$lang::w52</th><th><font face=$font_face size=$font_size color=$text_table_head>$lang::w53 </th><th><font face=$font_face size=$font_size color=$text_table_head>$lang::w54 </th><th><font face=$font_face size=$font_size color=$text_table_head>$lang::w31</th><th><font face=$font_face size=$font_size color=$text_table_head> $lang::55</th><th><font face=$font_face size=$font_size color=$text_table_head> $lang::w56</th></tr>\n";

   open(MSGS,"$basedir/$mesgfile");
   @lines = <MSGS>;
   close(MSGS);

   foreach $line (@lines) {
      if ($line =~ /<!--top: (.*)--><li><a href="\1\.$ext">(.*)<\/a> - <b>(.*)<\/b>\s+<i>(.*)<\/i>/) {
         push(@ENTRIES,$1);
         $SUBJECT{$1} = $2;
         $AUTHOR{$1} = $3;
         $DATE{$1} = $4;
      }
   }

   @SORTED_ENTRIES = (sort { $a <=> $b } @ENTRIES);
   $max = pop(@SORTED_ENTRIES);
   $min = shift(@SORTED_ENTRIES);

   print "<input type=hidden name=\"min\" value=\"$min\">\n";
   print "<input type=hidden name=\"max\" value=\"$max\">\n";
   print "<input type=hidden name=\"type\" value=\"remove\">\n";

   foreach (@ENTRIES) {
      print "<tr>\n";
      print "<th><font face=$font_face size=$font_size color=$text_table><b>$_</b> </th><td><font face=$font_face size=$font_size color=$text_table><input type=radio name=\"$_\" value=\"all\"> </td><td><input type=radio name=\"$_\" value=\"single\"> </td><td><font face=$font_face size=$font_size color=$text_table><a href=\"$baseurl/$_\.$ext\">$SUBJECT{$_} </a></td><td><font face=$font_face size=$font_size color=$text_table>$AUTHOR{$_} </td><td><font face=$font_face size=$font_size color=$text_table>$DATE{$_}<br></td>\n";

      print "</tr>\n";
   }
   print "</table>\n";
   print "<center><p>\n";
   print "<input type=submit value=\"$lang::w57\"> <input type=reset>\n";
   print "</form>\n";
	&Account::footer;
}

###########################################################################
# Remove By Number                                                        #
#       This method is useful to see in what order the messages were      #
#   added to the wwwboard.html document.                                  #
###########################################################################

elsif ($command eq 'remove_by_num') {
   &Account::header($lang::w1,'',$lang::w49);
   print "<font face=$font_face size=$font_size><B>$lang::w58</b></font><br><BR>\n";
   print "<table border=0 width=80%><TR align=center><TD><font face=$font_face size=$font_size>$lang::w59";
   print "</font></TD></TR></TABLE>\n";
   print "<hr size=1 noshade width=75%>\n";
   print "<form method=POST action=\"$cgiurl\">\n";
   print "$Account::hidden_variables\n";
   print "<input type=hidden name=\"wwwboard_admin\" value=\"submit\">\n";
   print "<input type=hidden name=\"action\" value=\"remove\">\n";
   print "<center><table border=1 cellpadding=4 cellspacing=1 bgcolor=$table_bg>\n";
   print "<tr bgcolor=$table_head_bg>\n";
   print "<th><font face=$font_face size=$font_size color=$text_table_head>$lang::w52 </th><th><font face=$font_face size=$font_size color=$text_table_head>Thread </th><th><font face=$font_face size=$font_size color=$text_table_head>Single </th><th><font face=$font_face size=$font_size color=$text_table_head>Subject </th><th> <font face=$font_face size=$font_size color=$text_table_head>Author</th><th> <font face=$font_face size=$font_size color=$text_table_head>Date</th></tr>\n";

   open(MSGS,"$basedir/$mesgfile");
   @lines = <MSGS>;
   close(MSGS);

   foreach $line (@lines) {
      if ($line =~ /<!--top: (.*)--><li><a href="\1\.$ext">(.*)<\/a> - <b>(.*)<\/b>\s+<i>(.*)<\/i>/) {
         push(@ENTRIES,$1);
         $SUBJECT{$1} = $2;
         $AUTHOR{$1} = $3;
         $DATE{$1} = $4;
      }
   }

   @SORTED_ENTRIES = (sort { $a <=> $b } @ENTRIES);
   $max = pop(@SORTED_ENTRIES);
   $min = shift(@SORTED_ENTRIES);
   push(@SORTED_ENTRIES,$max);
   unshift(@SORTED_ENTRIES,$min);

   print "<input type=hidden name=\"min\" value=\"$min\">\n";
   print "<input type=hidden name=\"max\" value=\"$max\">\n";
   print "<input type=hidden name=\"type\" value=\"remove\">\n";

   foreach (@SORTED_ENTRIES) {
      print "<tr>\n";
      print "<th><font face=$font_face size=$font_size color=$text_table><b>$_</b> </th><td><input type=radio name=\"$_\" value=\"$lang::w60\"> </td><td><input type=radio name=\"$_\" value=\"$lang::w61\"> </td><td><font face=$font_face size=$font_size color=$text_table><a href=\"$baseurl/$_\.$ext\">$SUBJECT{$_} </a></td><td><font face=$font_face size=$font_size color=$text_table>$AUTHOR{$_} </td><td><font face=$font_face size=$font_size color=$text_table>$DATE{$_}<br></td>\n";

      print "</tr>\n";
   }
   print "</table>\n";
   print "<center><p>\n";
   print "<input type=submit value=\"$lang::w62\"> <input type=reset>\n";
   print "</form>\n";
	&Account::footer;
	exit;
}

###########################################################################
# Remove By Date                                                          #
#       Using this method allows you to delete all messages posted before #
#   a certain date.                                                       #
###########################################################################

elsif ($command eq 'remove_by_date') {
   &Account::header($lang::w1,'',$lang::w49);
   print "<font face=$font_face size=$font_size><B>$lang::w63</b></font><br><BR>\n";
   print "<table border=0 width=80%><TR align=center><TD><font face=$font_face size=$font_size>$lang::w64\n";
   print "</font></TD></TR></TABLE>\n";
   print "<hr size=1 noshade width=75%><center>\n";
   print "<form method=POST action=\"$cgiurl\">\n";
   print "<input type=hidden name=\"wwwboard_admin\" value=\"submit\">\n";
   print "$Account::hidden_variables\n";
   print "<input type=hidden name=\"action\" value=\"remove_by_date_or_author\">\n";
   print "<input type=hidden name=\"type\" value=\"remove_by_date\">\n";
   print "<center>\n";
   print "<center><table border=1 cellpadding=4 cellspacing=1 bgcolor=$table_bg>\n";
   print "<tr bgcolor=$table_head_bg>\n";
   print "<th><font face=$font_face size=$font_size color=$text_table_head>X </th><th><font face=$font_face size=$font_size color=$text_table_head>$lang::w56 </th><th><font face=$font_face size=$font_size color=$text_table_head>$lang::w65 </th><th><font face=$font_face size=$font_size color=$text_table_head>$lang::w66<br></th></tr>\n";

   open(MSGS,"$basedir/$mesgfile");
   @lines = <MSGS>;
   close(MSGS);

   foreach $line (@lines) {
      if ($line =~ /<!--top: (.*)--><li><a href="\1\.$ext">.*<\/a> - <b>.*<\/b>\s+<i>(.*)<\/i>/) {
         $date = $2;
         if ($use_time == 1) {
            ($time,$day) = split(/\s+/,$date);
         }
         else {
            $day = $date;
         }
         $DATE{$1} = $day;
      }
   }

   undef(@used_values);
   foreach $value (sort (values %DATE)) {
      $match = '0';
      $value_number = 0;
      foreach $used_value (@used_values) {
         if ($value eq $used_value) {
            $match = '1';
            last;
         }
      }
      if ($match == '0') {
         undef(@values); undef(@short_values);
         foreach $key (keys %DATE) {
            if ($value eq $DATE{$key}) {
               $key_url = "<a href=\"$baseurl/$key\.$ext\">$key</a>";
               push(@values,$key_url);
	       push(@short_values,$key);
               $value_number++;
            }
         }
         $form_value = $value;
         $form_value =~ s/\//_/g;
         print "<tr>\n";
         print "<td><input type=checkbox name=\"$form_value\" value=\"@short_values\"> </td><th><font face=$font_face size=$font_size color=$text_table>$value </th><td><font face=$font_face size=$font_size color=$text_table>$value_number </td><td><font face=$font_face size=$font_size color=$text_table>@values<br></td>\n";
         print "</tr>\n";
         push(@used_values,$value);
         push(@used_form_values,$form_value);
      }
   }
   print "</table><p>\n";
   print "<input type=hidden name=\"used_values\" value=\"@used_form_values\">\n";
   print "<input type=submit value=\"$lang::w62\"> <input type=reset>\n";
   print "</form></center>\n";
&Account::footer;
}

###########################################################################
# Remove By Author                                                        #
#       This option makes a list of all known authors and then groups     #
#    together there postings and allows you to remove them all at once.   #
###########################################################################

elsif ($command eq 'remove_by_author') {
   &Account::header($lang::w1,'',$lang::w49);
   print "<font face=$font_face size=$font_size><B>$lang::w67</b></font><br><BR>\n";
   print "<table border=0 width=80%><TR align=center><TD><font face=$font_face size=$font_size>$lang::w68\n";
   print "</font></TD></TR></TABLE>\n";
   print "<hr size=1 noshade width=75%><center>\n";
   print "<form method=POST action=\"$cgiurl\">\n";
   print "<input type=hidden name=\"wwwboard_admin\" value=\"submit\">\n";
   print "$Account::hidden_variables\n";
   print "<input type=hidden name=\"action\" value=\"remove_by_date_or_author\">\n";
   print "<input type=hidden name=\"type\" value=\"remove_by_author\">\n";
   print "<center><table border=1 cellpadding=4 cellspacing=1 bgcolor=$table_bg>\n";
   print "<tr bgcolor=$table_head_bg>\n";
   print "<th><font face=$font_face size=$font_size color=$text_table_head>X </th><th><font face=$font_face size=$font_size color=$text_table_head>$lang::w55 </th><th><font face=$font_face size=$font_size color=$text_table_head>$lang::w65 </th><th><font face=$font_face size=$font_size color=$text_table_head>$lang::w66<br></th></tr>\n";

   open(MSGS,"$basedir/$mesgfile");
   @lines = <MSGS>;
   close(MSGS);

   foreach $line (@lines) {
      if ($line =~ /<!--top: (.*)--><li><a href="\1\.$ext">.*<\/a> - <b>(.*)<\/b>\s+<i>.*<\/i>/) {
         $AUTHOR{$1} = $2;
      }
   }

   undef(@used_values);
   foreach $value (sort (values %AUTHOR)) {
      $match = '0';
      $value_number = 0;
      foreach $used_value (@used_values) {
         if ($value eq $used_value) {
            $match = '1';
            last;
         }
      }
      if ($match == '0') {
         undef(@values); undef(@short_values);
         foreach $key (keys %AUTHOR) {
            if ($value eq $AUTHOR{$key}) {
               $key_url = "<a href=\"$baseurl/$key\.$ext\">$key</a>";
               push(@values,$key_url);
               push(@short_values,$key);
               $value_number++;
            }
         }
         $form_value = $value;
         $form_value =~ s/ /_/g;
         print "<tr>\n";
         print "<td><input type=checkbox name=\"$form_value\" value=\"@short_values\"> </td><th align=left><font face=$font_face size=$font_size color=$text_table>$value </th><td><font face=$font_face size=$font_size color=$text_table>$value_number </td><td><font face=$font_face size=$font_size color=$text_table>@values<br></td>\n";
         print "</tr>\n";
         push(@used_values,$value);
         push(@used_form_values,$form_value);
      }
   }
   print "</table><p>\n";
   print "<input type=hidden name=\"used_values\" value=\"@used_form_values\">\n";
   print "<input type=submit value=\"$lang::w62\"> <input type=reset>\n";
   print "</form></center>\n";
   &Account::footer;
   exit;
}

###########################################################################
# Remove Action                                                           #
#       This portion is used by the options remove and remove_by_num.     #
###########################################################################

elsif ($INPUT{'action'} eq 'remove') {

   for ($i = $INPUT{'min'}; $i <= $INPUT{'max'}; $i++) {
      if ($INPUT{$i} eq $lang::w60) {
         push(@ALL,$i);
      }
      elsif ($INPUT{$i} eq $lang::w61) {
         push(@SINGLE,$i);
      }
   }

   open(MSGS,"$basedir/$mesgfile");
   @lines = <MSGS>;
   close(MSGS);

   foreach $single (@SINGLE) {
      foreach ($j = 0;$j <= @lines;$j++) {
         if ($lines[$j] =~ /<!--top: $single-->/) {
            splice(@lines, $j, 3);
            $j -= 3;
         }
         elsif ($lines[$j] =~ /<!--end: $single-->/) {
            splice(@lines, $j, 1);
            $j--;
         }
      }
      $filename = "$basedir/$single\.$ext";
      if (-e $filename) {
         unlink("$filename") || push(@NOT_REMOVED,$single);
      }
      else {
         push(@NO_FILE,$single);
      }
      push(@ATTEMPTED,$single);
   }

   foreach $all (@ALL) {
      undef($top); undef($bottom);
      foreach ($j = 0;$j <= @lines;$j++) {
         if ($lines[$j] =~ /<!--top: $all-->/) {
            $top = $j;
         }
         elsif ($lines[$j] =~ /<!--end: $all-->/) {
            $bottom = $j;
         }
      }
      if ($top && $bottom) {
         $diff = ($bottom - $top);
         $diff++;
         for ($k = $top;$k <= $bottom;$k++) {
            if ($lines[$k] =~ /<!--top: (.*)-->/) {
               push(@DELETE,$1);
            }
         }
         splice(@lines, $top, $diff);
         foreach $delete (@DELETE) {
            $filename = "$basedir/$delete\.$ext";
            if (-e $filename) {
               unlink($filename) || push(@NOT_REMOVED,$delete);
            }
            else {
               push(@NO_FILE,$delete);
            }
            push(@ATTEMPTED,$delete);
         }
      }
      else {
         push(@TOP_BOT,$all);
      }
   }

   open(WWWBOARD,">$basedir/$mesgfile");
   print WWWBOARD @lines;
   close(WWWBOARD);      

   &return_html_admin($INPUT{'type'});

}

###########################################################################
# Remove Action by Date or Author                                         #
#       This portion is used by the method remove_by_date or 		  #
#   remove_by_author.     		  				  #
###########################################################################

elsif ($INPUT{'action'} eq 'remove_by_date_or_author') {

   @used_values = split(/\s/,$INPUT{'used_values'});
   foreach $used_value (@used_values) {
      @misc_values = split(/\s/,$INPUT{$used_value});
      foreach $misc_value (@misc_values) {
         push(@SINGLE,$misc_value);
      }
   }

   open(MSGS,"$basedir/$mesgfile");
   @lines = <MSGS>;
   close(MSGS);

   foreach $single (@SINGLE) {
      foreach ($j = 0;$j <= @lines;$j++) {
         if ($lines[$j] =~ /<!--top: $single-->/) {
            splice(@lines, $j, 3);
            $j -= 3;
         }
         elsif ($lines[$j] =~ /<!--end: $single-->/) {
            splice(@lines, $j, 1);
            $j--;
         }
      }
      $filename = "$basedir/$single\.$ext";
      if (-e $filename) {
         unlink("$filename") || push(@NOT_REMOVED,$single);
      }
      else {
         push(@NO_FILE,$single);
      }
      push(@ATTEMPTED,$single);
   }

   open(WWWBOARD,">$basedir/$mesgfile");
   print WWWBOARD @lines;
   close(WWWBOARD);

   &return_html_admin($INPUT{'type'});

}


else {
   print "This is no place for a kid like you......\n";
}

}

sub return_html_admin {
   $type = $_[0];
     &Account::header($lang::w1,'',$lang::w69);
   if ($type eq 'remove') {

      print "<center><font face=$font_face size=$font_size><B>$lang::w70</b></font></center>\n";
   }
   elsif ($type eq 'remove_by_num') {

      print "<center><font face=$font_face size=$font_size><B>$lang::w70</b></font></center>\n";
   }
   elsif ($type eq 'remove_by_date') {

      print "<center><font face=$font_face size=$font_size><B>$lang::w70</b></font></center>\n";
   }
   elsif ($type eq 'remove_by_author') {

      print "<center><font face=$font_face size=$font_size><B>$lang::w70</b></font></center>\n";
   }
   if ($type =~ /^remove/) {
      print "<Table width=80% border=0><TR><TD><font face=$font_face size=$font_size>$lang::w71</TD></TR></TABLE>\n";
 
      print "<b>$lang::w72</b> @ATTEMPTED<p>\n";
      if (@NOT_REMOVED) {
         print "<b>$lang::w73</b> @NOT_REMOVED<p>\n";
      }
      if (@NO_FILE) {
         print "<b>$lang::w74</b> @NO_FILE<p>\n";
      }
      print "<hr size=1 noshade width=75%><center>\n";

print <<EOF;
<FORM METHOD=POST ACTION="$files::manager">
$Account::hidden_variables
<input type="hidden" name="action" value="main">
<input type="Submit" name="" value=" $lang::w75 ">
</form>
EOF

&Account::footer;
	}
}



########## WWWBOARD HEADER ##########
sub user_header {

print <<EOF;
<HTML>
<HEAD><TITLE>$free_name :: $lang::w1</TITLE>
</HEAD>
<BODY>
EOF

undef $/;


if ($wwwboard_header) {
	open (HEAD, "$main::path/wwwboard_header.txt");
	$head = <HEAD>;
	close (HEAD);
	print "$head<BR>";	
}
elsif ($Account::file_header) {

	open (HEAD, "$main::path/$Account::file_header");
	$head = <HEAD>;
	close (HEAD);
	
	unless ($Account::file_header eq "header_html.txt") {
		$head =~ s/.*\n//;
	}
	print "$head<BR>";	
}
$/="\n";

}

########## WWWBOARD FOOTER ###########
sub user_footer {

undef $/;

if ($wwwboard_header) {
	open (HEAD, "$main::path/wwwboard_footer.txt");
	$head = <HEAD>;
	close (HEAD);
	print "$head<BR>";	
}
elsif ($Account::file_footer) {

	open (HEAD, "$main::path/$Account::file_footer");
	$head = <HEAD>;
	close (HEAD);
	
	unless ($Account::file_footer eq "footer_html.txt") {
		$head =~ s/.*\n//;
	}
	print "$head<BR>";	
}
$/="\n";

}


1;

# Version/Other: 3.26
# Licensed to: Robert R FLower
# Downloaded on: 8/21/00, 9:11 p.m.
# IP Address: 24.64.143.114
# Session: JvNsWNqK

